// $Id: mapstraction_cck_geocoder.js,v 1.1 2010/07/13 12:39:05 plopesc Exp $ 

Mapstraction.geocoder = Mapstraction.geocoder || {};

Drupal.behaviors.openlayers_geocoder = function (context) {

  if (Drupal.jsAC) {
  /**
   * Hides the autocomplete suggestions
   */
  Drupal.jsAC.prototype.hidePopup = function (keycode) {
    // Select item if the right key or mousebutton was pressed
    if (this.selected && ((keycode && keycode != 46 && keycode != 8 && keycode != 27) || !keycode)) {
      this.input.value = this.selected.autocompleteValue;
    }
    // Hide popup
    var popup = this.popup;
    if (popup) {
      this.popup = null;
      $(popup).fadeOut('fast', function() { $(popup).remove(); });
      // Add-on for OpenLayer Geocoder module
      if ($(this.input).attr('geoautocomplete')&& this.input.value != '') {
        geocoder = new Drupal.Geocoder(this);
        geocoder.process(this.input.value);
      }
    }
    this.selected = false;
    
  };
  
  }
};

Mapstraction.geocoder.callback = function(geocoded_location){
  Mapstraction.maps[Mapstraction.geocoder.mapid].map.setCenterAndZoom(geocoded_location.point,
  	parseInt(Mapstraction.geocoder.maps[Mapstraction.geocoder.mapid].geocode.zoom));
}

/**
 * Geocoder object
 */
Drupal.Geocoder = function (data) {
  this.data = data;
};

/**
 * Performs a search
 */
Drupal.Geocoder.prototype.process = function (query) {
  var mapid = $(this.data.input).attr('rel');
  Mapstraction.geocoder.component.swap(Mapstraction.geocoder.maps[mapid].geocode.provider);
  var address = {}; 
  address.address = query;
  Mapstraction.geocoder.mapid = mapid;
  Mapstraction.geocoder.component.geocode(address);
}

jQuery(document).ready(function(){
	if(Mapstraction.isSet(Drupal.settings.mapstraction)){
		Mapstraction.geocoder.maps = Drupal.settings.mapstraction.maps
		for (var mapid in Mapstraction.geocoder.maps) {
			if(Mapstraction.geocoder.maps[mapid].geocode.provider != 'none'){
		      if(!Mapstraction.isSet(Mapstraction.geocoder.component)){
		      	Mapstraction.geocoder.component = new mxn.MapstractionGeocoder(Mapstraction.geocoder.callback,Mapstraction.geocoder.maps[mapid].geocode.provider,function(){});
		      }	
		      // Define click actions for Geocode button
		      $('#edit-'+mapid.replace('_','-')+'-geocode-button').click(function() {
		        var mapid = $(this).attr('rel');
		        Mapstraction.geocoder.component.swap(Mapstraction.geocoder.maps[mapid].geocode.provider);
		        var address = {}; 
		        address.address = $('#edit-' + mapid.replace('_','-') + '-geocode-field').val();
		        Mapstraction.geocoder.mapid = mapid;
		        Mapstraction.geocoder.component.geocode(address);
		        return false;
		      });
		    }	
		}
	}
})







